using System;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.Security.Cryptography;

namespace MachineKeyGenerator
{
    public static class Program
    {
        [STAThread]
        public static void Main(string[] args)
        {
            Application.OleRequired();
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            using (Form dialog = CreateDialog())
            using (ApplicationContext context = new ApplicationContext(dialog))
            {
                Application.Run(context);
            }
        }

        public static Form CreateDialog()
        {
            Form dialog = new Form();
            dialog.AutoScaleMode = AutoScaleMode.None;
            dialog.Size = new Size(350, 340);
            dialog.FormBorderStyle = FormBorderStyle.FixedDialog;
            dialog.MinimizeBox = false;
            dialog.MaximizeBox = false;
            dialog.Text = "ASP.NET <machineKey> Generator";
            dialog.Padding = new Padding(15);

            FlowLayoutPanel layoutPanel = new FlowLayoutPanel();
            layoutPanel.Parent = dialog;
            layoutPanel.Dock = DockStyle.Fill;
            layoutPanel.FlowDirection = FlowDirection.TopDown;

            Label aspnet11Label = new Label();
            aspnet11Label.Parent = layoutPanel;
            aspnet11Label.AutoSize = true;
            aspnet11Label.Text = "ASP.NET 1.1 <machineKey> element: ";

            TextBox aspnet11 = new TextBox();
            aspnet11.Parent = layoutPanel;
            aspnet11.Size = new Size(300, 100);
            aspnet11.Multiline = true;
            aspnet11.WordWrap = true;
            aspnet11.ReadOnly = true;
            aspnet11.ScrollBars = ScrollBars.Both;
            aspnet11.Text = getASPNET11machinekey();

            Label aspnet20Label = new Label();
            aspnet20Label.Parent = layoutPanel;
            aspnet20Label.AutoSize = true;
            aspnet20Label.Text = "ASP.NET 2.0 <machineKey> element: ";

            TextBox aspnet20 = new TextBox();
            aspnet20.Parent = layoutPanel;
            aspnet20.Size = new Size(300, 100);
            aspnet20.Multiline = true;
            aspnet20.WordWrap = true;
            aspnet20.ReadOnly = true;
            aspnet20.ScrollBars = ScrollBars.Both;
            aspnet20.Text = getASPNET20machinekey();

            Button refreshButton = new Button();
            refreshButton.Parent = layoutPanel;
            refreshButton.AutoSize = true;
            refreshButton.Text = "&Regenerate";
            refreshButton.Click += new EventHandler(delegate(object _sender, EventArgs _args)
            {
                aspnet11.Text = getASPNET11machinekey();
                aspnet20.Text = getASPNET20machinekey();
            });

            return dialog;
        }

        public static string getASPNET20machinekey()
        {
            StringBuilder aspnet20machinekey = new StringBuilder();
            string key64byte = getRandomKey(64);
            string key32byte = getRandomKey(32);
            aspnet20machinekey.Append("<machineKey\n");
            aspnet20machinekey.Append(" validationKey=\"" + key64byte + "\"\n");
            aspnet20machinekey.Append(" decryptionKey=\"" + key32byte + "\"\n");
            aspnet20machinekey.Append(" validation=\"SHA1\" decryption=\"AES\"\n");
            aspnet20machinekey.Append("/>\n");
            return aspnet20machinekey.ToString();
        }

        public static string getASPNET11machinekey()
        {
            StringBuilder aspnet11machinekey = new StringBuilder();
            string key64byte = getRandomKey(64);
            string key24byte = getRandomKey(24);

            aspnet11machinekey.Append("<machineKey");
            aspnet11machinekey.Append(" validationKey=\"" + key64byte + "\"\n");
            aspnet11machinekey.Append(" decryptionKey=\"" + key24byte + "\"\n");
            aspnet11machinekey.Append(" validation=\"SHA1\"\n");
            aspnet11machinekey.Append("/>\n");
            return aspnet11machinekey.ToString();
        }

        public static string getRandomKey(int bytelength)
        {
            byte[] buff = new byte[bytelength];
            RNGCryptoServiceProvider rng = new RNGCryptoServiceProvider();
            rng.GetBytes(buff);
            StringBuilder sb = new StringBuilder(bytelength * 2);
            for (int i = 0; i < buff.Length; i++)
                sb.Append(string.Format("{0:X2}", buff[i]));
            return sb.ToString();
        }
    }
}

